// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-go_gapic. DO NOT EDIT.

package appengine_test

import (
	"context"

	appengine "cloud.google.com/go/appengine/apiv1"
	"google.golang.org/api/iterator"
	appenginepb "google.golang.org/genproto/googleapis/appengine/v1"
)

func ExampleNewFirewallClient() {
	ctx := context.Background()
	c, err := appengine.NewFirewallClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	// TODO: Use client.
	_ = c
}

func ExampleFirewallClient_ListIngressRules() {
	ctx := context.Background()
	c, err := appengine.NewFirewallClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &appenginepb.ListIngressRulesRequest{
		// TODO: Fill request struct fields.
	}
	it := c.ListIngressRules(ctx, req)
	for {
		resp, err := it.Next()
		if err == iterator.Done {
			break
		}
		if err != nil {
			// TODO: Handle error.
		}
		// TODO: Use resp.
		_ = resp
	}
}

func ExampleFirewallClient_BatchUpdateIngressRules() {
	ctx := context.Background()
	c, err := appengine.NewFirewallClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &appenginepb.BatchUpdateIngressRulesRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.BatchUpdateIngressRules(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleFirewallClient_CreateIngressRule() {
	ctx := context.Background()
	c, err := appengine.NewFirewallClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &appenginepb.CreateIngressRuleRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.CreateIngressRule(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleFirewallClient_GetIngressRule() {
	ctx := context.Background()
	c, err := appengine.NewFirewallClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &appenginepb.GetIngressRuleRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.GetIngressRule(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleFirewallClient_UpdateIngressRule() {
	ctx := context.Background()
	c, err := appengine.NewFirewallClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &appenginepb.UpdateIngressRuleRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.UpdateIngressRule(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleFirewallClient_DeleteIngressRule() {
	ctx := context.Background()
	c, err := appengine.NewFirewallClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &appenginepb.DeleteIngressRuleRequest{
		// TODO: Fill request struct fields.
	}
	err = c.DeleteIngressRule(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
}
