// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-go_gapic. DO NOT EDIT.

package cx_test

import (
	"context"

	cx "cloud.google.com/go/dialogflow/cx/apiv3"
	"google.golang.org/api/iterator"
	cxpb "google.golang.org/genproto/googleapis/cloud/dialogflow/cx/v3"
)

func ExampleNewFlowsClient() {
	ctx := context.Background()
	c, err := cx.NewFlowsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	// TODO: Use client.
	_ = c
}

func ExampleFlowsClient_CreateFlow() {
	ctx := context.Background()
	c, err := cx.NewFlowsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.CreateFlowRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.CreateFlow(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleFlowsClient_DeleteFlow() {
	ctx := context.Background()
	c, err := cx.NewFlowsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.DeleteFlowRequest{
		// TODO: Fill request struct fields.
	}
	err = c.DeleteFlow(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
}

func ExampleFlowsClient_ListFlows() {
	ctx := context.Background()
	c, err := cx.NewFlowsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.ListFlowsRequest{
		// TODO: Fill request struct fields.
	}
	it := c.ListFlows(ctx, req)
	for {
		resp, err := it.Next()
		if err == iterator.Done {
			break
		}
		if err != nil {
			// TODO: Handle error.
		}
		// TODO: Use resp.
		_ = resp
	}
}

func ExampleFlowsClient_GetFlow() {
	ctx := context.Background()
	c, err := cx.NewFlowsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.GetFlowRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.GetFlow(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleFlowsClient_UpdateFlow() {
	ctx := context.Background()
	c, err := cx.NewFlowsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.UpdateFlowRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.UpdateFlow(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleFlowsClient_TrainFlow() {
	ctx := context.Background()
	c, err := cx.NewFlowsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.TrainFlowRequest{
		// TODO: Fill request struct fields.
	}
	op, err := c.TrainFlow(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}

	err = op.Wait(ctx)
	if err != nil {
		// TODO: Handle error.
	}
}

func ExampleFlowsClient_ValidateFlow() {
	ctx := context.Background()
	c, err := cx.NewFlowsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.ValidateFlowRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.ValidateFlow(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleFlowsClient_GetFlowValidationResult() {
	ctx := context.Background()
	c, err := cx.NewFlowsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.GetFlowValidationResultRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.GetFlowValidationResult(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleFlowsClient_ImportFlow() {
	ctx := context.Background()
	c, err := cx.NewFlowsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.ImportFlowRequest{
		// TODO: Fill request struct fields.
	}
	op, err := c.ImportFlow(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}

	resp, err := op.Wait(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleFlowsClient_ExportFlow() {
	ctx := context.Background()
	c, err := cx.NewFlowsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.ExportFlowRequest{
		// TODO: Fill request struct fields.
	}
	op, err := c.ExportFlow(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}

	resp, err := op.Wait(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}
