// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-go_gapic. DO NOT EDIT.

package eventarc_test

import (
	"context"

	eventarc "cloud.google.com/go/eventarc/apiv1"
	"google.golang.org/api/iterator"
	eventarcpb "google.golang.org/genproto/googleapis/cloud/eventarc/v1"
)

func ExampleNewClient() {
	ctx := context.Background()
	c, err := eventarc.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	// TODO: Use client.
	_ = c
}

func ExampleClient_GetTrigger() {
	ctx := context.Background()
	c, err := eventarc.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &eventarcpb.GetTriggerRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.GetTrigger(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleClient_ListTriggers() {
	ctx := context.Background()
	c, err := eventarc.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &eventarcpb.ListTriggersRequest{
		// TODO: Fill request struct fields.
	}
	it := c.ListTriggers(ctx, req)
	for {
		resp, err := it.Next()
		if err == iterator.Done {
			break
		}
		if err != nil {
			// TODO: Handle error.
		}
		// TODO: Use resp.
		_ = resp
	}
}

func ExampleClient_CreateTrigger() {
	ctx := context.Background()
	c, err := eventarc.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &eventarcpb.CreateTriggerRequest{
		// TODO: Fill request struct fields.
	}
	op, err := c.CreateTrigger(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}

	resp, err := op.Wait(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleClient_UpdateTrigger() {
	ctx := context.Background()
	c, err := eventarc.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &eventarcpb.UpdateTriggerRequest{
		// TODO: Fill request struct fields.
	}
	op, err := c.UpdateTrigger(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}

	resp, err := op.Wait(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleClient_DeleteTrigger() {
	ctx := context.Background()
	c, err := eventarc.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &eventarcpb.DeleteTriggerRequest{
		// TODO: Fill request struct fields.
	}
	op, err := c.DeleteTrigger(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}

	resp, err := op.Wait(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}
