// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-go_gapic. DO NOT EDIT.

package iap_test

import (
	"context"

	iap "cloud.google.com/go/iap/apiv1"
	iappb "google.golang.org/genproto/googleapis/cloud/iap/v1"
	iampb "google.golang.org/genproto/googleapis/iam/v1"
)

func ExampleNewIdentityAwareProxyAdminClient() {
	ctx := context.Background()
	c, err := iap.NewIdentityAwareProxyAdminClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	// TODO: Use client.
	_ = c
}

func ExampleIdentityAwareProxyAdminClient_SetIamPolicy() {
	ctx := context.Background()
	c, err := iap.NewIdentityAwareProxyAdminClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &iampb.SetIamPolicyRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.SetIamPolicy(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleIdentityAwareProxyAdminClient_GetIamPolicy() {
	ctx := context.Background()
	c, err := iap.NewIdentityAwareProxyAdminClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &iampb.GetIamPolicyRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.GetIamPolicy(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleIdentityAwareProxyAdminClient_TestIamPermissions() {
	ctx := context.Background()
	c, err := iap.NewIdentityAwareProxyAdminClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &iampb.TestIamPermissionsRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.TestIamPermissions(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleIdentityAwareProxyAdminClient_GetIapSettings() {
	ctx := context.Background()
	c, err := iap.NewIdentityAwareProxyAdminClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &iappb.GetIapSettingsRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.GetIapSettings(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleIdentityAwareProxyAdminClient_UpdateIapSettings() {
	ctx := context.Background()
	c, err := iap.NewIdentityAwareProxyAdminClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &iappb.UpdateIapSettingsRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.UpdateIapSettings(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}
