// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-go_gapic. DO NOT EDIT.

package transcoder_test

import (
	"context"

	transcoder "cloud.google.com/go/video/transcoder/apiv1"
	"google.golang.org/api/iterator"
	transcoderpb "google.golang.org/genproto/googleapis/cloud/video/transcoder/v1"
)

func ExampleNewClient() {
	ctx := context.Background()
	c, err := transcoder.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	// TODO: Use client.
	_ = c
}

func ExampleClient_CreateJob() {
	ctx := context.Background()
	c, err := transcoder.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &transcoderpb.CreateJobRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.CreateJob(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleClient_ListJobs() {
	ctx := context.Background()
	c, err := transcoder.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &transcoderpb.ListJobsRequest{
		// TODO: Fill request struct fields.
	}
	it := c.ListJobs(ctx, req)
	for {
		resp, err := it.Next()
		if err == iterator.Done {
			break
		}
		if err != nil {
			// TODO: Handle error.
		}
		// TODO: Use resp.
		_ = resp
	}
}

func ExampleClient_GetJob() {
	ctx := context.Background()
	c, err := transcoder.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &transcoderpb.GetJobRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.GetJob(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleClient_DeleteJob() {
	ctx := context.Background()
	c, err := transcoder.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &transcoderpb.DeleteJobRequest{
		// TODO: Fill request struct fields.
	}
	err = c.DeleteJob(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
}

func ExampleClient_CreateJobTemplate() {
	ctx := context.Background()
	c, err := transcoder.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &transcoderpb.CreateJobTemplateRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.CreateJobTemplate(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleClient_ListJobTemplates() {
	ctx := context.Background()
	c, err := transcoder.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &transcoderpb.ListJobTemplatesRequest{
		// TODO: Fill request struct fields.
	}
	it := c.ListJobTemplates(ctx, req)
	for {
		resp, err := it.Next()
		if err == iterator.Done {
			break
		}
		if err != nil {
			// TODO: Handle error.
		}
		// TODO: Use resp.
		_ = resp
	}
}

func ExampleClient_GetJobTemplate() {
	ctx := context.Background()
	c, err := transcoder.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &transcoderpb.GetJobTemplateRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.GetJobTemplate(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleClient_DeleteJobTemplate() {
	ctx := context.Background()
	c, err := transcoder.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &transcoderpb.DeleteJobTemplateRequest{
		// TODO: Fill request struct fields.
	}
	err = c.DeleteJobTemplate(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
}
